<?php
namespace Teknisa\PLA\Services;

use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\Libs\Util\Environment;

class AlergenicoProduto extends \Teknisa\GER\Controllers\TeknisaCrud {
	
	protected $servicoService;
	protected $crudService;
	protected $dataSourceManager;
	protected $util;
	protected $dtprocessa;
	protected $dataSourceName;
	protected $dataSourceNameToSave = false;
	protected $parameterBagColumns = array();
	protected $novoCodigo;
	protected $connection;
	protected $entityManager;
	protected $environment;

	public function __construct($crudService, $parameterBag , $dataSourceManager, $util, $novoCodigo, $connection, $entityManager, $environment) {
		parent::__construct($crudService, $parameterBag);
		$this->crudService = $crudService;
		$this->dataSourceManager = $dataSourceManager;
		$this->util = $util;
		$this->novoCodigo = $novoCodigo;
		$this->connection = $connection;
		$this->entityManager = $entityManager;
		$this->environment = $environment;
	}
	
	public function getIntervaloProdutos($prodIni, $prodFim){
        $query = "SELECT
					    CDPRODUTO
					FROM
					    PRODUTO
					WHERE
					        IDPRODATIVPR = 'S'
					    AND CDNVPRODUTO = (
					        SELECT
					            MAX(CDNVPRODUTO)
					        FROM
					            PRODUTO
					    )
					    AND CDARVPROD BETWEEN :PRODINI AND :PRODFIM
					ORDER BY
					    CDARVPROD";
        $params = array(
            "PRODINI" => $prodIni,
            "PRODFIM" => $prodFim
        );
        return $this->entityManager->getConnection()->fetchAll($query, $params);
 
        
    }
	
	 public function saveAlergenicoProduto(DTO\Request $request, DTO\Response $response){
        
        $dataSet = $request->getDataSet()->getRows();
       
        $prodIni = $dataSet[0]['PRODINI'];
        $prodFim = $dataSet[0]['PRODFIM'];
        $alergenicos = $dataSet[0]['ALERGENICOS'];
    
        $intervaloProdutos = $this->getIntervaloProdutos($prodIni, $prodFim);
   
        $dados = [];
        $currentTime = $this->environment->getCurrentTime()->format("d/m/Y H:i:s");
        foreach($intervaloProdutos as $produtos) {
        	
        	foreach($alergenicos as $aler) {
        		
        		$aler['CDPRODUTO'] = $produtos['CDPRODUTO'];
        		$aler['__is_new'] = $dataSet[0]['__is_new'];
        		$aler['DTULTATU'] = $currentTime;
                $aler['NRORGULTATU'] = $this->environment->getNrOrgTrab();
                $aler['CDOPERULTATU'] = $this->environment->getCdOperador();
                $aler['DTINCLUSAO'] = $currentTime;
                $aler['NRORGINCLUSAO'] = $this->environment->getNrOrgTrab();
                $aler['CDOPERINCLUSAO'] = $this->environment->getCdOperador();
	
        		array_push($dados,$aler);
        		
        	}
        	
        }
        
        if($dataSet[0]['OPERACAO'] == 'I'){
        	
        	foreach($dados as $data){
               try {
                  $this->crudService->save('alergenicoprod_alergenico', array($data));
               } catch(\Exception $error){
                  $msg = $error->getMessage();
                  if(!strpos($error,"ORA-00001")){ 
                      $response->setError(new Error($error->getMessage(), 500));
                  }
               }
        	}
        	
        }else if($dataSet[0]['OPERACAO'] == 'E'){
        	
        	$dataSetDelete = new DataSet('alergenicoprod_alergenico', $dados);
        	
        	try {
                $this->crudService->delete($response,$dataSetDelete);
            } catch (\Exception $e) {
                $response->setError(new Error($e->getMessage(), 500));
            }
        	
        }
    }
    
    
}